modules/admin/controllers/CompensationController.php
<?php
/**
 * Created by PhpStorm.
 * User: Bramnik
 * Date: 9/11/2017
 * Time: 2:26 PM
 */



namespace app\modules\admin\controllers;
use app\modules\admin\components\AdminController;
use Yii;
use app\models\Compensation;
use app\models\CompensationSearch;

class CompensationController extends AdminController

{
    /**
     * @inheritdoc
     */
 /*   public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }
*/
    /**
     * Lists all Compensation models.
     * @return mixed
     */
    public function actionIndex()
    {
        $searchModel = new CompensationSearch();
        $dataProvider = $searchModel->search(Yii::$app->request->queryParams);

        return $this->render('index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Compensation model.
     * @param integer $id
     * @return mixed
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new Compensation model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new Compensation();

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id]);
        } else {
            return $this->render('create', [
                'model' => $model,
            ]);
        }
    }

    /**
     * Updates an existing Compensation model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);
        $approvedOld = $model->is_approved;
        //var_dump($model->is_approved);
        if ($model->load(Yii::$app->request->post())){
                //var_dump($model->is_approved);die;
                if($approvedOld == FALSE && !strcmp($model->is_approved, '1'))
                {
                    $visitdate = new \DateTime('now', new \DateTimeZone('UTC'));
                    $model->approved_date = $visitdate->format('Y-m-d H:i:s');

                }

                $model->save();
            return $this->redirect(['view', 'id' => $model->id]);
        } else {
            return $this->render('update', [
                'model' => $model,
            ]);
        }
    }

    /**
     * Deletes an existing Compensation model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Compensation model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Compensation the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Compensation::findOne($id)) !== null) {
            return $model;
        } else {
            throw new NotFoundHttpException('The requested page does not exist.');
        }
    }
}

modules/admin/views/compensation/_form.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/* @var $this yii\web\View */
/* @var $model app\models\Compensation */
/* @var $form yii\widgets\ActiveForm */
?>

<div class="compensation-form">

    <?php $form = ActiveForm::begin(); ?>

    <?= $form->field($model, 'user_id')->textInput() ?>

    <?= $form->field($model, 'producer_id')->textInput() ?>

    <?= $form->field($model, 'product_id')->textInput() ?>

    <?= $form->field($model, 'amount')->textInput() ?>

    <?= $form->field($model, 'percentReturn')->textInput() ?>

    <?= $form->field($model, 'sum')->textInput() ?>

    <?= $form->field($model, 'approved_date')->textInput() ?>

    <?= $form->field($model, 'statement_date')->textInput() ?>

    <?= $form->field($model, 'end_date')->textInput() ?>

    <?= $form->field($model, 'is_approved')->dropDownList(\app\models\enums\IsApproved::getClientValues(),['prompt'=>t('Выберите нужное')])?>



    <?= $form->field($model, 'completed')->dropDownList(\app\models\enums\Completed::getClientValues(),['prompt'=>t('Выберите нужное')]) ?>

    <div class="form-group">
        <?= Html::submitButton($model->isNewRecord ? t('Создать') : t('Изменить'), ['class' => $model->isNewRecord ? 'btn btn-success' : 'btn btn-primary']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div>

modules/admin/views/compensation/_search.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;
use app\models\enums\LocaleEnum;

/* @var $this yii\web\View */
/* @var $model app\models\CompensationSearch */
/* @var $form yii\widgets\ActiveForm */
?>


<?
$containerOptions = ['class' => 'collapse', 'id' => 'collapseFilters'];
if ($model->isActiveFilter()) {
    Html::addCssClass($containerOptions, 'in');
}
?>
<?php
$RtLStyle = ['direction'=> 'rtl'];
if(LocaleEnum::isRTL()){  Html::addCssStyle($containerOptions,$RtLStyle, true) ; }
?>
<?= Html::beginTag('div', $containerOptions) ?>
<?php $form = ActiveForm::begin([
    'action' => ['index'],
    'method' => 'get',
    'fieldConfig' => [
        'template'  => "{input}\n{label}\n{hint}\n{error}",],
]); ?>
    <?= $form->field($model, 'id') ?>

    <?= $form->field($model, 'user_id')->dropDownList($model->getUserList(),['prompt'=>t('Не выбрано')])  ?>

    <?php // echo $form->field($model, 'producer_id') ?>

    <?= $form->field($model, 'product_id')->dropDownList($model->getProductList(),['prompt'=>t('Не выбрано')]) ?>




    <?= $form->field($model, 'is_approved')->dropDownList(\app\models\enums\IsApproved::getClientValues(),['prompt'=>t('Не выбрано')]) ?>

    <?= $form->field($model, 'completed')->dropDownList(\app\models\enums\Completed::getClientValues(),['prompt'=>t('Не выбрано')]) ?>

    <?php // echo $form->field($model, 'amount') ?>

    <?php // echo $form->field($model, 'percentReturn') ?>

    <?php // echo $form->field($model, 'sum') ?>

    <?=  $form->field($model, 'statement_date') ?>

    <?php // echo  $form->field($model, 'end_date') ?>



    <?php // echo $form->field($model, 'approved_date') ?>

<div class="form-group">
    <?php
    $SearchBtn = ['class' => 'btn btn-primary'];
    $ResetBtn = ['class' => 'btn btn-default'];
    if (LocaleEnum::isRTL()) {
        Html::addCssClass($SearchBtn, 'pull-right');
        Html::addCssClass($ResetBtn, 'pull-right');
    }

    ?>

    <?= Html::submitButton(t('Поиск'),$SearchBtn) ?>
    <?= Html::resetButton(t('Сброс'), $ResetBtn) ?>


</div>

    <?php ActiveForm::end(); ?>

</div>

modules/admin/views/compensation/create.php
<?php

use yii\helpers\Html;


/* @var $this yii\web\View */
/* @var $model app\models\Compensation */

$this->title = t('Создать заявку на компенсацию');
$this->params['breadcrumbs'][] = ['label' => t('Все заявки на компенсации'), 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="compensation-create">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

modules/admin/views/compensation/index.php
<?php

use yii\helpers\Html;
use yii\grid\GridView;
use app\models\enums\IsApproved;
use app\models\enums\Completed;
use app\models\enums\LocaleEnum;

/* @var $this yii\web\View */
/* @var $searchModel app\models\CompensationSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = t('Заявки на компенсацию за непроданный товар с истекающим сроком хранения');
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="compensation-index">
    <h1><?= Html::encode($this->title) ?></h1>


    <?php
    $optionsBtn = ['class' => 'btn btn-primary', 'role' => 'button', 'data-toggle' => 'collapse','aria-expanded'=>'false','aria-controls'=>'collapseFilters'];
    if (LocaleEnum::isRTL()) {
        Html::addCssClass($optionsBtn, 'pull-right');
    }
    ?>
    <?=Html::a(t('Фильтры'),"#collapseFilters", $optionsBtn);
    ?>

    <? if($searchModel->isActiveFilter()): ?>
        <?= Html::a(t('Сбросить фильтр'), [\yii\helpers\Url::to("/" .$this->context->action->getUniqueId())], ['class' => 'btn btn-default']); ?>
    <? endif; ?>

    <?= $this->render('_search', ['model' => $searchModel]); ?>

    <?php  if (LocaleEnum::isRTL()) {
        //Массив с колонками выносим в переменную для удобства
        $columns = [
            [
                'class' => 'yii\grid\ActionColumn',
                'template' => '{view}{update}',
                'buttons' => [
                    'view' => function ($url, $model, $key) {
                        $url = \yii\helpers\Url::to(['compensation/view', 'id' => $model->id]);
                        return Html::a(Html::tag('span', '', ['class' => 'glyphicon glyphicon-eye-open']), $url);
                    },

                    'update' => function ($url, $model, $key) {
                        $url = \yii\helpers\Url::to(['compensation/update', 'id' => $model->id]);
                        return Html::a(Html::tag('span', '', ['class' => 'glyphicon glyphicon-pencil']), $url);
                    },

                ],

            ],
            [
                'attribute' => 'completed',
                'value' => function($model){
                    return Completed::getClientValue($model->completed);
                }
            ],
            'approved_date',
            // 'completed',
            // 'approved_date',
            // 'is_approved',
            // 'sum',
            // 'percentReturn',
            [
                'attribute' => 'is_approved',
                'value' => function($model){
                    return IsApproved::getClientValue($model->is_approved);
                }
            ],
            'end_date',
            'statement_date',
            'amount',
            [
                'attribute'=>'product_id',
                'value' => function($model){
                    return $model->getProduct()->one()->name_he;
                }
            ],
            [
                'attribute'=>'producer_id',
                'value' => function($model){
                    return $model->getProducer()->one()->name;
                }

            ],
            [
                'attribute'=>'user_id',
                'value' => function($model){
                    return $model->getUser()->one()->shop_name;
                }

            ],
            'id',
            ['class' => 'yii\grid\SerialColumn'],

        ];
    }
    else{
        $columns = [
            ['class' => 'yii\grid\SerialColumn'],

            'id',
            [
                'attribute'=>'user_id',
                'value' => function($model){
                    return $model->getUser()->one()->shop_name;
                }

            ],
            [
                'attribute'=>'producer_id',
                'value' => function($model){
                    return $model->getProducer()->one()->name;
                }

            ],
            //  'product_id',
            [
                'attribute'=>'product_id',
                'value' => function($model){
                    return $model->getProduct()->one()->name;
                }
            ],
            'amount',
            'statement_date',
            'end_date',
            [
                'attribute' => 'is_approved',
                'value' => function($model){
                    return IsApproved::getClientValue($model->is_approved);
                }
            ],
            // 'percentReturn',
            // 'sum',
            // 'is_approved',
            // 'approved_date',
            // 'completed',

            'approved_date',
            [
                'attribute' => 'completed',
                'value' => function($model){
                    return Completed::getClientValue($model->completed);
                }
            ],

            [
                'class' => 'yii\grid\ActionColumn',
                'template' => '{view}{update}',
                'buttons' => [
                    'view' => function ($url, $model, $key) {
                        $url = \yii\helpers\Url::to(['compensation/view', 'id' => $model->id]);
                        return Html::a(Html::tag('span', '', ['class' => 'glyphicon glyphicon-eye-open']), $url);
                    },

                    'update' => function ($url, $model, $key) {
                        $url = \yii\helpers\Url::to(['compensation/update', 'id' => $model->id]);
                        return Html::a(Html::tag('span', '', ['class' => 'glyphicon glyphicon-pencil']), $url);
                    },

                ],

            ],

        ];
    }
    ?>

    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        // 'filterModel' => $searchModel,
        'formatter' => ['class' => 'yii\i18n\Formatter','nullDisplay' => t('не задано')],

        'columns' => $columns,
    ]);?>
</div>

modules/admin/views/compensation/update.php
<?php
use app\models\enums\LocaleEnum;
use yii\helpers\Html;
use yii\widgets\ActiveForm;
use yii\widgets\DetailView;
/* @var $this yii\web\View */
/* @var $model app\models\Compensation */
if("he-IL" ==  Yii::$app->language) {
    $this->title = $model->id . t('Редактировать заявки на компенсацию №: ') ;
}
else{
    $this->title = t('Редактировать заявки на компенсацию №: ') . $model->id;
}
$this->params['breadcrumbs'][] = ['label' => t('Заявки на компенсацию'), 'url' => ['index']];
$this->params['breadcrumbs'][] = ['label' => $model->id, 'url' => ['view', 'id' => $model->id]];
$this->params['breadcrumbs'][] = t('Редактировать');
?>
<div class="compensation-update">

    <h1><?= Html::encode($this->title) ?></h1>

    <?php
    $template = '<tr><th{captionOptions}>{label}</th><td{contentOptions}>{value}</td></tr>';
    if (LocaleEnum::isRTL()) {
        $template = '<tr><td{contentOptions}>{value}</td><th{captionOptions}>{label}</th></tr>';
    }
    ?>

    <?= DetailView::widget([
        'model' => $model,
        'template' => $template,
        'attributes' => [
            'id',
            [
                'attribute' => 'user_id',
                'value' => function($model){
                    return $model->getUser()->one()->shop_name;
                }
            ],
            [
                'attribute' => 'product_id',
                'value' => function($model){
                    if (LocaleEnum::isRTL()) {
                        return $model->getProduct()->one()->name_he;
                    }
                    else{
                        return $model->getProduct()->one()->name;
                    }
                }
            ],


            [
                'attribute' => 'producer_id',
                'value' => function($model){
                    return $model->getProducer()->one()->name;
                }
            ],
            'amount',
            'end_date',
            'statement_date',

        ],
    ]) ?>
<div class="compensation-form"<?php if(LocaleEnum::isRTL()){ ?>  style="direction: rtl;" <?php  } ?> >
    <?php $form = ActiveForm::begin(); ?>
    <?= $form->field($model, 'percentReturn')->textInput() ?>
    <?= $form->field($model, 'sum')->textInput() ?>
    <?= $form->field($model, 'is_approved')->dropDownList(\app\models\enums\IsApproved::getClientValues(),['prompt'=>t('Выберите нужное')])   ?>
    <?php // echo  $form->field($model, 'approved_date')->textInput() ?>
    <?= $form->field($model, 'completed')->dropDownList(\app\models\enums\Completed::getClientValues(),['prompt'=>t('Выберите нужное')])  ?>
    <div class="form-group">
        <?= Html::submitButton($model->isNewRecord ? t('Создать') : t('Изменить'), ['class' => $model->isNewRecord ? 'btn btn-success' : 'btn btn-primary']) ?>
    </div>

    <?php ActiveForm::end(); ?>
</div>
</div>

modules/admin/views/compensation/view.php
<?php

use yii\helpers\Html;
use yii\widgets\DetailView;
use app\models\enums\IsApproved;
use app\models\enums\Completed;
use app\models\enums\LocaleEnum;

/* @var $this yii\web\View */
/* @var $model app\models\Compensation */

$this->title = t('№ заявки ') . $model->id;
$this->params['breadcrumbs'][] = ['label' => t('Заявки на компенсацию'), 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="compensation-view">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?php
        $classChangeBtn = ['class' => 'btn btn-primary'];
        if (LocaleEnum::isRTL()) {
            Html::addCssClass($classChangeBtn, 'pull-right');
        }
        ?>

        <?= Html::a(t('Внести изменения'), ['update', 'id' => $model->id], $classChangeBtn) ?>

    </p>

    <?php
    $template = '<tr><th{captionOptions}>{label}</th><td{contentOptions}>{value}</td></tr>';
    if (LocaleEnum::isRTL()) {
        $template = '<tr><td{contentOptions}>{value}</td><th{captionOptions}>{label}</th></tr>';
    }
    ?>

    <?= DetailView::widget([
        'model' => $model,
        'template' => $template,
        'attributes' => [
            'id',
            [
                'attribute' => 'user_id',
                'value' => function($model){
                    return $model->getUser()->one()->shop_name;
                }
            ],
            [
                'attribute' => 'producer_id',
                'value' => function($model){
                    return $model->getProducer()->one()->name;
                }
            ],
            [
                'attribute' => 'product_id',
                'value' => function($model){
                    if (LocaleEnum::isRTL()) {
                        return $model->getProduct()->one()->name_he;
                    }
                    else{
                        return $model->getProduct()->one()->name;
                    }
                }
            ],

            'amount',
            'percentReturn',
            'sum',
            'statement_date',
            'end_date',
            [
                'attribute' => 'is_approved',
                'value' => function($model){
                    return IsApproved::getClientValue($model->is_approved);
                }
            ],
            'approved_date',
            [
                'attribute' => 'completed',
                'value' => function($model){
                    return Completed::getClientValue($model->completed);
                }
            ],
        ],
    ]) ?>

</div>